Package org.codehaus.groovy.transform.tailrec

# Class ReturnStatementToIterationConverter

java.lang.Object
org.codehaus.groovy.transform.tailrec.ReturnStatementToIterationConverter

public class ReturnStatementToIterationConverter extends Object
Translates all return statements into an invocation of the next iteration. This can be either - "continue LOOP_LABEL": Outside closures - "throw LOOP_EXCEPTION": Inside closures

Moreover, before adding the recur statement the iteration parameters (originally the method args) are set to their new value. To prevent variable aliasing parameters will be copied into temp vars before they are changes so that their current iteration value can be used when setting other params.

There's probably place for optimizing the amount of variable copying being done, e.g. parameters that are only handed through must not be copied at all.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ReturnStatementToIterationConverter()`
  Creates a converter that uses the default recurrence statement.
  `ReturnStatementToIterationConverter(Statement recurStatement)`
  Creates a converter that uses the supplied recurrence statement.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Statement`
  `convert(ReturnStatement statement, Map<Integer,Map<String,Object>> positionMapping)`
  Converts a recursive return statement into iterative assignments followed by the recur statement.
  `Statement`
  `getRecurStatement()`
  Returns the statement used to trigger the next iteration.
  `void`
  `setRecurStatement(Statement recurStatement)`
  Sets the statement used to trigger the next iteration.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ReturnStatementToIterationConverter

    public ReturnStatementToIterationConverter()
    Creates a converter that uses the default recurrence statement.

  - ### ReturnStatementToIterationConverter

    public ReturnStatementToIterationConverter(Statement recurStatement)
    Creates a converter that uses the supplied recurrence statement.
    Parameters:
      `recurStatement` - the statement that advances to the next iteration

- ## Method Details

  - ### convert

    public Statement convert(ReturnStatement statement, Map<Integer,Map<String,Object>> positionMapping)
    Converts a recursive return statement into iterative assignments followed by the recur statement.
    Parameters:
      `statement` - the return statement to convert
      `positionMapping` - the parameter mapping keyed by argument position
    Returns:
      the converted statement, or the original statement if it is not a method call

  - ### getRecurStatement

    public Statement getRecurStatement()
    Returns the statement used to trigger the next iteration.
    Returns:
      the recurrence statement

  - ### setRecurStatement

    public void setRecurStatement(Statement recurStatement)
    Sets the statement used to trigger the next iteration.
    Parameters:
      `recurStatement` - the recurrence statement to use